#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

/*

	bash-3.0-geinpeek-0.2 ڵ ν緯

	( install-0.2.c )

	 # gcc install-0.2.c -o install-0.2
	   # ./install-0.2
*/


/* ġ ̿ ӽõ丮 */
#define	DOWNLOAD_DIR	"/root/tmp"

/* ANSI  ũ */
#define SET_ANSI(){     printf("\033[0;44;36m"); }
#define UNSET_ANSI(){   printf("\033[0m");      }


/* Ÿ */
int download_file(char *src_url);
int checking_file(char *bin_file);
int xtract_package(char *src_url);
void select_and_patch();
void compile_geinpeek_bash();
void make_install();
void make_clean();


/* ġ ʿ ʼ ƿƼ  */
char needed[5][16]=
{
    "/bin/bash",
    "/usr/bin/patch",
	"/usr/bin/wget",
	"/bin/tar",
	"\x00",
};

/* 󿡼 ٿε ҽŰ  */
char download_list[3][128]=
{
    "http://ftp.gnu.org/pub/gnu/bash/bash-3.0.tar.gz",
    "http://kldp.net/frs/download.php/3191/bash-3.0-geinpeek-0.2.tar.gz",
	"\x00",
};

/* ʼġ ϸ */
char needed_patch_list[3][64]=
{
	"Makefile.in-geinpeek.diff",
	"ghelper.c",				/* ڸ Է ͸  */
	"\x00",
};

/*   ġŰƮ ϸ */
char patchkit_list[3][64]=
{
	"execute_cmd.c-geinpeek.diff",		/*   ġ */
	"shell.c-geinpeek.diff",		/* α ˸ ġ ( õ ) */
	"\x00",	
};


/* ġϷ ˸ */
char cong[]=
{
	"BASH-GEINPEEK  迡 Ű ȯմϴ ^-^/\n\n"
	"  : # ghelper 90.txt\n"
};
	

int main()
{

	unsigned int i = 0, ret = 0;

	system("rm -rf /root/tmp");

	if(strcmp(getenv("SHELL"), "/bin/bash") == 0){
		fprintf(stderr, "\n\n ġ Ͻ÷ root  ⺻ csh  \n"
				"α  õϼžմϴ.\n\n");
		return(1);
	}

	/* 1 ܰ : GNU bash & geinpeek ҽڵ带  ¼ҽ 丮 ٿε. */

	for(i = 0; download_list[i][0] != '\x00'; i++){
		if(download_file(download_list[i]) != 0){
			ret ++;
			fprintf(stderr, "ҽ ڵ(tar.gz) ٿε忡 ߽ϴ:\n\t=> %s\n", download_list[i]);
		}
	}

	printf("\n");

	if(ret != 0)
		return(2);

	ret = 0;

	/* 2 ܰ : ġ ʿ ƿƼ ġǾ Ȯ */
	
	for(i = 0; needed[i][0] != '\x00'; i++){
		if(checking_file(needed[i]) != 0){
			ret ++;
			fprintf(stderr, "䱸Ǵ ƿƼ : %s\n", needed[i]);
		} else{
			printf(": %s : ߰!\n", needed[i]);
		}
	}
	
	if(ret != 0)
		return(3);

	printf("\n");

	/* 3 ܰ : ҽڵ Ű   */

	for(i = 0; download_list[i][0] != '\x00'; i++){
		if(xtract_package(download_list[i]) != 0){
			ret ++;
			fprintf(stderr, "ٿε (tar.gz)   :\n\t=> %s\n", download_list[i]);
		} else{
			printf(": %s : !\n", download_list[i]);
		}
	}

	if(ret != 0)
		return(4);

	ret = 0;

	printf("\n");

	/* 4 ܰ : bash-geinpeek  ġŰƮ ϵ patch  üҽƮ ġ */
	
	select_and_patch();	

	printf("\n");
		
	/* 5 ܰ :  üҽ  */
	
	compile_geinpeek_bash();

	printf("\n");

	/* 6 ܰ :  bash    ý /bin/bash  ü */
	
	make_install();

	/* 7 ܰ : ġϸ޽   */
	
	SET_ANSI();
	fprintf(stdout, "%s\n", cong);
	UNSET_ANSI();

	/* 8 ܰ : ġ ӽõ丮  */

	make_clean();



}

#define	OK_MARK		"200 OK"

int download_file(char *src_url)
{
	char sho[128];
	FILE *pfp;
	char msg_buf[2048];
	unsigned int indx = 0;

	sprintf(sho, "%s %s -P %s", needed[2], src_url, DOWNLOAD_DIR);

	if((pfp = popen(sho, "r")) == NULL){
		fprintf(stderr, "\n\n%s : \n\n", sho);
		goto failed;
	}

	while(!feof(pfp))
		msg_buf[indx++] = fgetc(pfp);

	if(strstr(msg_buf, OK_MARK) != NULL){
		fprintf(stderr, "\n\n%s : ҽ  ߰ ߽ϴ.\n\n", src_url);
		goto failed;
	}


success:
	pclose(pfp);
	return(0);

failed:
	pclose(pfp);
	make_clean();

}


void make_clean()
{
	char sho[128];

	sprintf(sho, "rm -rf %s\n", DOWNLOAD_DIR);
	system(sho);

	printf(": rm -rf %s\n", DOWNLOAD_DIR);

	printf("bye!\n");

	exit(1);

}


int checking_file(char *bin_file)
{
	return access(bin_file, X_OK);
}

#define	ERROR_MARK	"Error exit"

int xtract_package(char *src_url)
{
        char sho[128];
        FILE *pfp;
        char msg_buf[65535];
        unsigned int indx = 0, indxx = 0;
	char *src_file;


	/* URL   ϸ  */

	
	if((src_file = strrchr(src_url, '/')) == NULL){
		fprintf(stderr, "\n\n%s : ߸ URL Դϴ.\n\n", src_url);
		goto failed;
	}
	
        sprintf(sho, "%s xzvf %s%s -C %s", needed[3], DOWNLOAD_DIR, src_file, DOWNLOAD_DIR);

        if((pfp = popen(sho, "r")) == NULL){
                fprintf(stderr, "\n\n%s : \n\n", sho);
                goto failed;
        }

        while(!feof(pfp))
                msg_buf[indx++] = fgetc(pfp);

        if(strstr(msg_buf, ERROR_MARK) != NULL){
                fprintf(stderr, "\n\n%s : ҽ   \n\n", src_file);
                goto failed;
        }


success:
        pclose(pfp);
        return(0);

failed:
        pclose(pfp);
        make_clean();
		
}

void select_and_patch()
{
	unsigned int indsx = 0;
	char sho[128];
	char c;

	for(indsx = 0; needed_patch_list[indsx][0] != '\x00'; indsx++){
		sprintf(sho, "mv %s/bash-3.0-geinpeek-0.2/%s %s/bash-3.0", 
			DOWNLOAD_DIR, needed_patch_list[indsx], DOWNLOAD_DIR);
		system(sho);

        if(strstr(needed_patch_list[indsx], ".diff") != NULL){
			printf("ʼ ġ : %s [ Ǿ ]\n", needed_patch_list[indsx]);
			sprintf(sho, "cd %s/bash-3.0/; patch -f < %s", DOWNLOAD_DIR, needed_patch_list[indsx]);
			system(sho);
		}
	}

        for(indsx = 0; patchkit_list[indsx][0] != '\x00'; indsx++){
                sprintf(sho, "mv %s/bash-3.0-geinpeek-0.2/%s %s/bash-3.0",
                        DOWNLOAD_DIR, patchkit_list[indsx], DOWNLOAD_DIR);
                system(sho);

		SET_ANSI();
		printf("BASH-GEINPEEK : %s Ͻðڽϱ ? (Y/N) ", patchkit_list[indsx]);
		UNSET_ANSI();

		c = ' ';

		fflush(stdin);
		c = fgetc(stdin);	
		
		if(c == 'y' || c == 'Y'){
	        sprintf(sho, "cd %s/bash-3.0/; patch -f < %s", DOWNLOAD_DIR, patchkit_list[indsx]);
			system(sho);
        }
		getchar();
        }
}

void compile_geinpeek_bash()
{
	char sho[128];

	printf("BASH-GEINPEEK :    ..\n\n");

	sprintf(sho, "cd %s/bash-3.0/; ./configure; make", DOWNLOAD_DIR);
	system(sho);

	SET_ANSI();
	printf("\n\nBASH-GEINPEEK :    Ϸ!!\n\n");
	UNSET_ANSI();

}

void make_install()
{
	char sho[128];

	printf("BASH-GEINPEEK : ϵ ̳ʸ  丮 մϴ.\n\n");
	
	printf("backup: /bin/bash to /root/bash\n");
	system("cp /bin/bash /root/bash");

	sprintf(sho, "cd %s/bash-3.0/; mv bash /bin/bash; mv ghelper /sbin/ghelper; chmod 700 /sbin/ghelper");
	system(sho);

	printf("install: bash( ǵ ý) -> /bin/bash\n");
	printf("install: ghelper(͸ ) -> /sbin/ghelper\n");
	
}



